 	ORG 0000H	;	
Y:	EQU       059H	;	HEX VALUE OF Y.
N:	EQU       04EH	;	HEX VALUE OF N.
MEM:	EQU       65	;	START OF RAM FOR STORAGE.
SERPR:	CLR EA	;	DISABLE ALL INTERRUPT SPECIFIC TO SBC. 
	CLR ET1	;	DISABLE T1 INTERRUPT OF TIMER SPECIFIC TO SBC 1.
	MOV SCON,#RTE8U	;	01010010 B-4 RXD EN, B-6 8 B UART MD, B-1 TXD EN.
	MOV TMOD,#T1AR8	;	8 BIT AUTO RELOAD TIMER COUNTER MODE TH#1 HOLDS SET.
	MOV TH1,#B1200	;	SET BAUD RATE OF COMMUNICATION TO 1200.
	SETB TR1	;	TIMER 1 RUN CONTROL ON, ON TIMER 1.
		;	
DELAB:	LCALL PSCRN	;	PRINT ON SCREEN BELOW LISTED STRINGS.
	DFB "Welcome to DE Labs"	;	SAY SOMETING HERE FIRST DISPLAYED ON SCREEN.
	DFB BEEP,CR,LF	;	CONTROL CHARACTERS.
	DFB ESC	;	END OF PRINT SCREEN.
		;	
ASKYO:	LCALL PSCRN	;	PRINT ON SCREEN BELOW LISTED STRINGS.
	DFB "Reply Y or N " CR,CR	;	SAY SOMETING HERE FIRST DISPLAYED ON SCREEN.
	DFB "Press ENTER" , BEEP	;	MANY BEEPS.
	DFB CR, LF	;	CARRIGE RETURN, LINE FEED.
	DFB ESC	;	END OF PRINT SCREEN.
		;	
	MOV R0,#MEM	;	SET R0 TO START STORAGE.
INOUT:	LCALL TYPIN	;	CALL PROG TO READ PORT AND TO ECHO.
	CJNE A,#CR,INOUT	;	LOOP HERE TILL CARRIAGE RETURN FROM HOST.
	MOV R0,#MEM	;	SET MEM TO FIRST LOC.
	MOV A,@R0	;	READ FIRST MEM LOCATION.
	XRL A,#Y	;	COMPARE ACC WITH CHAR Y IF SAME THEN 
	JZ POSTV	;	ECHO POSTV MESSAGE
	MOV A,@R0	;	READ FIRST MEM LOCATION.
	XRL A,#N	;	COMPARE ACC WITH CHAR N IF SAME THEN
	JZ NEGTV	;	ECHO NEGTV MESSAGE
	LCALL PSCRN	;	PRINT ON SCREEN BELOW LISTED STRINGS.
	DFB LF,CR	;	CARRIGE RETURN, LINE FEED.
	DFB ESC	;	END OF PRINT SCREEN.
	LJMP ASKYO	;	KEEP LOOPING HERE.
		;	
POSTV:	LCALL PSCRN	;	PRINT ON SCREEN BELOW LISTED STRINGS.
	DFB "You are Nice",CR,LF	;	SAY SOMETING HERE FIRST DISPLAYED ON SCREEN.
	DFB "Thank You" , BEEP	;	MANY BEEPS.
	DFB BEEP, CR, LF, BEEP	;	CARRIGE RETURN, LINE FEED.
	DFB ESC	;	END OF PRINT SCREEN.
	LJMP ASKYO	;	KEEP LOOPING HERE.
		;	
NEGTV:	LCALL PSCRN	;	PRINT ON SCREEN BELOW LISTED STRINGS.
	DFB "Big Deal So What"CR	;	SAY SOMETING HERE FIRST DISPLAYED ON SCREEN.
	DFB "Get Lost" , BEEP,BEEP	;	MANY BEEPS.
	DFB BEEP, CR, LF, BEEP	;	CARRIGE RETURN, LINE FEED.
	DFB ESC	;	END OF PRINT SCREEN.
	LJMP ASKYO	;	KEEP LOOPING HERE.
		;	
TYPIN:	JNB RI,$	;	TRX COMPLETE THEN  TI=1, TI=0 THEN TRANSMIT GOING ON.
	CLR RI	;	CLR TI TO EN TRX TI SET TO 1 BY 8031 AFTER BYTE SENT.
	MOV A,SBUF	;	LOAD VALUE TO BE TRANSMITTED TO SBUF FOR SEND.
	ANL A,#07FH	;	AND 0111 1111 B TO SET D7 BIT OF RECD DATA 0 PARITY=0.
	ACALL TYPOT	;	READ IF HOST HAS TYPED IN AND ECHO IT IN TYPOT SUBROT.
	RET	;	RETURN
		;	
TYPOT:	JNB TI,$	;	TRX COMPLETE THEN  TI=1, TI=0 THEN TRANSMIT GOING ON.
	CLR TI	;	CLR TI TO EN TRX TI SET TO 1 BY 8031 AFTER BYTE SENT.
	MOV SBUF,A	;	LOAD VALUE TO BE TRANSMITTED TO SBUF FOR SEND.
	MOV @R0,A	;	STORE REPLY IN R5.
	INC R0	;	GO TO NEXT MEM LOCATION
	RET	;	RETURN
		;	
PSCRN:	POP DPH	;	THIS PRINTS THE DATA SHOWN BELOW ON THE TERMINAL.
	POP DPL	;	DEC DATA POINTER FROM WHERE PSCRN CALLED TO NEXT LINE.
TRXD1:	CLR A	;	CLEAR ACCUMULATOR TO 00.
	MOVC A,@A+DPTR	;	LOOK UP TABLE FETCH DATA FROM ADDR ACC+DPTR TO ACC
TRXD2:	JNB TI,$	;	TRX OVER TI=1 IF BUSY TI=0 LOAD A TO SBUF IF TI=1 
	CLR TI	;	CLR TI TO ENABLE TRANSMIT.
	MOV SBUF,A	;	LOAD ACC VALUE INTO SBUF FOR SEND.
	INC DPTR	;	INCREMENT 16 BIT DATAPOINTER TO FETCH NEXT DFB.
	CLR A	;	SET ACC 00.
	MOVC A,@A+DPTR	;	GET DATA FROM PROGRAM MEMORY TABLE ADDRESS AS IN DPTR.
	CJNE A,#ESC,TRXD2	;	TILL ESC COMES HERE JUMP TO TRXD2 AND SEND TILL ESC.
	MOV A,#1	;	ACC TO 1 AS DPTR+1 IS LOCATION OF COMMAND NEXT TO ESC.
	JMP @A+DPTR	;	JUMP BACK LIKE RETURN AS DPTR WAS LOST THIS IS DONE.
